
import random
import math

L1 = [9,21,37,11,19] 
v1 = 32

fname2 = "tabela.txt"   

x = math.inf
#      a b c d e f g
A3 = [[0,6,4,9,x,x,x], #a
      [6,0,3,x,5,x,x], #b
      [4,3,0,x,x,2,x], #c
      [9,x,x,0,x,4,9], #d
      [x,5,x,x,0,6,7], #e
      [x,x,2,4,6,0,x], #f
      [x,x,x,9,7,x,0]] #g

C3 = [23, 34, 12, 25, 67, 89, 56]


def sublista(L, v):
    """function documentation"""
    M = L.copy()
    S = []
    soma = 0
    for i in range(len(L)):
        k = math.floor(len(M) * random.random())
        if soma + M[k] <= v:
            S.append(M[k])
            soma = soma + M[k]
        M.pop(k)
    return (S, soma)

def sublista_melhor(L, v, n):
    """function documentation"""
    best = 0
    for i in range(n):
        (S, soma) = sublista(L, v)
        if soma > best:
            B = S
            best = soma
    return (B,best)
    
   
def dicionários(fname):
    """function documentation"""
    fid = open(fname, "r")    
    linha_1 = fid.readline().split(",")
    linhas  = fid.readlines()
    fid.close()
    chaves = []
    tipos = []
    for elem in linha_1:
        chs = elem.strip().split('/')
        chaves.append(chs[0].strip())
        tipos.append(chs[1].strip())
    dics = []
    for linha in linhas:
        dic = {}
        lin = linha.strip().split(",")
        for i in range(len(chaves)):
            if tipos[i] == "int":
                campo = int(lin[i])
            elif tipos[i] == "flt":
                campo = float(lin[i])
            else:
                campo = lin[i].strip()
            dic.update({chaves[i]:campo})
        dics.append(dic)
    return (chaves, dics)       
    

   
def capacidades(A, C):
    """function documentation"""
    T,out = prim(A)
    S,N = floyd(T)
    n = len(A)
    D = [ [ 0 for i in range(n) ] for j in range(n) ]
    for k in range(1,n):
        P = path(0,k,N)
        for i in range(1,len(P)):
            D[P[i-1]][P[i]] = D[P[i-1]][P[i]] + C[k]
            D[P[i]][P[i-1]] = D[P[i]][P[i-1]] + C[k]
    return D

#9 --------    

def prim(G):
    """ Returns the minimum spanning tree of graph G, 
    using the prim algorithm and a list of nodes that do
    not belong to the tree (if the graph is not connected).
    If the graph is connected, the list is empty)"""
    n = len(G)
    In = [0]
    Out = [i for i in range(1,n)]
    T = [ [ -1 for i in range(n) ] for j in range(n) ]
    for i in range(n):
        T[i][i] = 0
    while len(Out) > 0:
        min_arc = math.inf
        u = 0
        v = 0
        for i in In:
            for j in Out:
                if G[i][j] > 0 and G[i][j] < min_arc:
                    u = i
                    v = j
                    min_arc = G[i][j]
        if u == 0 and v == 0:
            return (T, Out)
        T[u][v] = G[u][v]
        T[v][u] = G[v][u]
        In.append(v)
        Out.remove(v)
    return (T, Out)

def floyd(G):
    """ Returns the minimum distances between any two modes 
    of graph G, using the Floyd-Warshall's algorithm."""
    n = len(G)
    D = [ [ math.inf for i in range(n) ] for j in range(n) ]
    N = [ [ j for j in range(n) ] for i in range(n) ] 
    for i in range(n):
        for j in range(n):
            if G[i][j] != -1:
                D[i][j]= G[i][j]
            else:
                N[i][j]= math.inf
    for k in range(n):
      for i in range(n):
         for j in range(n):
            if D[i][k] + D[k][j]  < D[i][j]:
               D[i][j] = D[i][k]  + D[k][j]
               N[i][j] = N[i][k] 
    return (D, N)

def path(u,v,Next):
    """ Returns the shortest path between nodes u and v,
    according to matrix Next computed with function floyd."""
    if Next[u][v] == math.inf: 
        return []
    P = [u]
    while u != v:
        u = Next[u][v]
        P.append(u)
    return P

      
    